<?php

# TODO: most code here could just be taken from mcdata.php

require("vars.php");

$err = FALSE;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">

<html>

<head>
  <title>Diag</title>
  <style type="text/css"> body { font-family: sans-serif; } </style>
</head>

<body>

<h1>MySQL</h1>

  <h3>&gt; Class init</h3>
  <p><pre><?php
    ob_start();
    $dbconnection = new McDataTest();
    $a = ob_get_contents();
    if(strlen(trim($a)) > 0) {
      echo "Something nasty happened:\n";
      $err = TRUE;
    } else
      echo "Ok.\n";
    ob_end_flush();
  ?></pre></p>

  <h3>&gt; MySQL connect</h3>
  <p><pre><?php echo $dbconnection->tryConnect(Vars::dbhost(), Vars::dbuser(), Vars::dbpass()) ?></pre></p>

<h1>Database</h1>

  <h3>&gt; Checking for existing McData DB and creating if necessary</h3>
  <p><pre><?php echo $dbconnection->dbAlreadyExistsOrNot(Vars::dbname()) ?></pre></p>

<h1>Tables</h1>

  <h3>&gt; Checking for existing tables and creating if necessary</h3>
  <p><pre><?php echo $dbconnection->tablesAlreadyExistOrNot(Vars::dbname()) ?></pre></p>

  <p><?php if($err == FALSE) echo "<i><b>Everything looks good!</b></i>" ?></p>

</body>
</html>

<?php

class McDataTest {

  var $db;

  function tryConnect($host, $user, $pass) {
    $this->db =  mysql_connect($host,$user,$pass)
      or die("Couldnt connect to MySQL: " . mysql_errno() . ": " . mysql_error());
    return "Works";
  }

  function dbAlreadyExistsOrNot($dbname) {
    $db_list = mysql_list_dbs($this->db);

    while ($row = mysql_fetch_assoc($db_list)) {
      if($row["Database"] == $dbname)
        return "Exists";
    }
    $html = "DB not there, creating...";
    $html .= $this->createDb($dbname);
    return $html;
  }

  function createDb($dbname) {
    $q = "CREATE DATABASE $dbname";
    mysql_query($q) 
      or die("Couldnt create database $dbname: " . mysql_errno() . ": " . mysql_error());
    return "\nmysql> $q\nOK.";
  }
  
  function tablesAlreadyExistOrNot($dbname) {
    $table_list = mysql_list_tables($dbname);

    $row = mysql_fetch_row($table_list);

    if($row[0] == "msgs") return "Yep, they're there.";

    $html = "Don't seem to exist, creating...\n";
    $html .= $this->createTables($dbname);
    return $html;
  }

  function createTables($dbname) {
    $html="";
    $msgs_q = "
      CREATE TABLE msgs (id INT UNSIGNED NOT NULL AUTO_INCREMENT,
                         pid INT UNSIGNED NOT NULL AUTO_INCREMENT,
                         name VARCHAR(64) NOT NULL,
                         date INT UNSIGNED NOT NULL,
                         message TEXT NOT NULL,
                         PRIMARY KEY (id))";

    $html .= "mysql>" . substr($msgs_q, 7) . "\n";
    mysql_query($msgs_q) or die("Couldn't create table in \$$msgs_q: ". mysql_errno() . ": " . mysql_error());
    $html .= "OK.\n";
    return $html;
  }
}








